
#include <vector>
#include "soap_likes.h"
#include "gatk_likes.h"
#include "bam_likes.h"
#include "analysisFunction.h"
#include "gen_likes.h"

extern int refToInt[256];
std::vector<char*> getFilenames(const char * name,int nItems);
//just return a list of bam files, we just need the filenames
std::vector<char *> getBams(argStruct &arguments){

  std::vector<char *> ret;
  //first find a .bam file
  for(int i=0;i<arguments.argc;i++)
    if(strstr(arguments.argv[i],".bam"))
      ret.push_back(strdup(arguments.argv[i]));
  int singleFile = ret.size();
  fprintf(stderr,"singlife=%d\n",singleFile);
  const char *fff = NULL;
  int nInd =-1;
  for(int i=0;i<arguments.argc;i++) {
    if(!strcmp(arguments.argv[i],"-bam")){
      if(singleFile){
	fprintf(stderr,"Youve supplied  a .bam file, and also -b will exit\n");
	exit(0);
      }
      if((i+1)<arguments.argc)
	fff = arguments.argv[i+1];
      else{
	fprintf(stderr,"Problems -b supplied as last argumens will exti\n");
	exit(0);
      }
    }
    if(!strcmp(arguments.argv[i],"-nInd")){
      if((i+1)<arguments.argc)
	nInd = atoi(arguments.argv[i+1]);
      else{
	fprintf(stderr,"Problems -nInd supplied as last argumens will exti\n");
	exit(0);
      }
    }
  }
  if((fff!=NULL)&&!singleFile)
    ret = getFilenames(fff,nInd);
  return ret;
}



void gen_likes::getOptions(argStruct arguments){

  //nasty hack, anders will hate this.
  //for the soap likes, we need the filenames.
  //so we parse this from the command line.

  bamNames = getBams(arguments);

  fprintf(stderr,"bamNames.size()=%lu\n",bamNames.size());

  qcharmin=0;
  qcharmax=51;
  rlen=100;
  doingGLest =0;

  
  //from command line
 
  GL=angsd::getArg("-GL",GL,arguments);
  qcharmin=angsd::getArg("-z",qcharmin,arguments);
  qcharmax=angsd::getArg("-Q",qcharmax,arguments);
  rlen = angsd::getArg("-L",rlen,arguments);
  if(GL==-1)
    return;

  if(GL<-2||GL>3){
    fprintf(stderr,"You supplied: -GL %d, -1)mpileup 0)soap 1)samtool 2)gatk\n",GL);
    exit(0);
  }

  if(GL==0){
    fprintf(stderr,"Doing SOAPsnp GL\n");
    fprintf(stderr,"Remember: -uniqueOnly 1 -only_proper_pairs 0, sleeping 2 seconds");
    sleep(2);
  }else if(GL==1){
    fprintf(stderr,"Doing samtools GL estimates\n");
    fprintf(stderr,"remember to set -L -z -Q also....\n");
    fprintf(stderr,"if in doubt run -doQsDist 1\n");
  }else if(GL==2)
    fprintf(stderr,"Doing gatk GL estimates\n");
  else {
    fprintf(stderr,"Unknown GL estimator: %d\n",GL);
    fflush(stderr);
    exit(0);
  }
}


gen_likes::gen_likes(argStruct arguments){
   //default
   GL=-1;//this means not to run
   //hasInit = 0;
   
   getOptions(arguments);

  //  fprintf(stderr,"\t genlikes init GL=%d\n",GL);
   if(GL==0)
     doingGLest= soap.init(bamNames,qcharmin,qcharmax,rlen);
   if(GL==1)
     bam_likes_init();
   fprintf(stderr,"perform GL estimation=%d\n",doingGLest); 
   
}


int doDump =0;

double ** gen_likes::call_likes(chunkyT *chk,char *refs) {
  if(GL==-1)
    return NULL;

  //  fprintf(stderr,"GL=%d\n",GL);
    double **likes = NULL;
    if(chk!=NULL){
      //      fprintf(stderr,"[%s] regstart=%d regstop=%d nSites=%d\n",__FUNCTION__,chk->regStart,chk->regStop,chk->nSites);
      likes = new double*[chk->nSites];
    }else
      fprintf(stderr,"[%s] recieved null chunk, will clean up aux data\n",__FUNCTION__);

    if(GL==0){
      soap.run(chk,likes,refs);
      if(doingGLest==0){//we dont estimate GL but make a calibration matrix
	delete [] likes;
	return NULL;
      }
    }else if(GL==1){
      call_bam(chk,likes);
    }else if(GL==2){
      call_gatk(chk,likes);
    }
    static FILE *mFile = NULL;
    static FILE *gFile = NULL;
    if(doDump){
      if(gFile==NULL){
	mFile = fopen("mafs.mafs","w");
	gFile = fopen("glfs.glfs","w");
      }
      if(chk!=NULL){
	for(int i=0;i<chk->nSites;i++)
	  fprintf(mFile,"%s\t%d\n",chk->refName,chk->nd[i][0].refPos+1);
	fflush(mFile);
	for(int i=0;i<chk->nSites;i++){
	  //	fprintf(stderr,"i=%d\n",i);
	  fwrite(likes[i],sizeof(double),10*chk->nSamples,gFile);
	}
      }else{
	fclose(mFile);
	fclose(gFile);
      }
    }
    return likes;
}

gen_likes::~gen_likes() {
  call_likes(NULL,NULL);
}
