#include <cmath>
#include "shared.h"
#include "analysisFunction.h"

class majorminor{
public:
  //none optional stuff
  //  FILE *outfile;
  int doMajorMinor;

  int doMaf;
  int doAsso;
  int doCovar;

  void run(funkyPars *pars);
  void printAndClean(funkyPars *pars);  
  void addDefault(funkyPars *pars);
  void openfile(const char *outfiles);
  majorminor(const char *outfiles,argStruct arguments,int inputtype);
  void getOptions(argStruct arguments);
  ~majorminor();
  //other stuff
  
};

void majorminor::getOptions(argStruct arguments){
  //default
  doMajorMinor=0;
  doMaf=0;
  doAsso=0;
  //from command line
  doMajorMinor=angsd::getArg("-doMajorMinor",doMajorMinor,arguments);


  doMaf=angsd::getArg("-doMaf",doMaf,arguments);
  doAsso=angsd::getArg("-doAsso",doAsso,arguments);
  doCovar=angsd::getArg("-doCovar",doCovar,arguments);

}

majorminor::majorminor(const char *outfiles,argStruct arguments,int inputtype){
  //should be changes so that it is a command options
 getOptions(arguments);

 if(inputtype!=0&&inputtype!=5&&(doMaf||doAsso)){
   //   fprintf(stdout,"Need to infer major minor, setting doMajorMinor to 1\n");
   //  doMajorMinor=1;

 }
 if(inputtype==5&&doMajorMinor){
   fprintf(stdout,"Error: Cannot estimate the major and minor based on posterior probabilities\n");
   exit(0);
 }
 if(doMajorMinor==0)
    return;

 //  fprintf(stderr,"Estimating major minor: %s\n",outfiles);
}

majorminor::~majorminor(){
  if(doMajorMinor==0)
    return;
}

void majorminor::printAndClean(funkyPars *pars){
  //cleaning moved to printfunky
  if(doMajorMinor==0)
    return;
}

void majorminor::run(funkyPars *pars){
  if(doMajorMinor!=1)//this is for using likes for estimating major/minor
    return;
  if(pars->likes==NULL){
    fprintf(stderr,"majorminor really wants likelhioods\n");
    exit(0);
  }
  if(pars->minor!=NULL&&pars->major!=NULL){
    // return;    

  }else{
    pars->major = new int [pars->numSites];
    pars->minor = new int [pars->numSites];
    for(int i=0;i<pars->numSites;i++){
      pars->major[i] = 4;
      pars->minor[i] = 4;
    }
  }
  float lmax;
  float totalLike;
  int choiceMajor;
  int choiceMinor;
  for(int s=0;s<pars->numSites;s++) {
    int keepList[pars->nInd];
    int keepInd =0;
    for(int i=0;i<pars->nInd;i++){
      int plugIn=0;
      for(int ii=0;ii<10;ii++)
	if(pars->likes[s][i*10+ii]!=0){
	  plugIn =1;
	  keepInd++;
	  break;
	}
      keepList[i] = plugIn;
    }
    pars->results->freq->keepInd[s] = keepInd;
    if(keepInd==0){
      pars->major[s] = 4;
      pars->major[s] = 4;
      continue;
    }

    //if we had a read then estimate the major/minor
    lmax=-100000000;
    for(int Imajor=0;Imajor<3;Imajor++) {
      for(int Iminor=(Imajor+1);Iminor<4;Iminor++){
	//fprintf(stderr,"%d %d\n",Imajor,Iminor);
	totalLike=0;
	for(int i=0;i<pars->nInd;i++)
	  totalLike+=angsd::addProtect3(pars->likes[s][i*10+angsd::majorminor[Imajor][Imajor]]+log(0.25),
				 pars->likes[s][i*10+angsd::majorminor[Imajor][Iminor]]+log(0.5),
				 pars->likes[s][i*10+angsd::majorminor[Iminor][Iminor]]+log(0.25)
				 );
	if(totalLike>lmax){
	  lmax=totalLike;
	  choiceMajor=Imajor;
	  choiceMinor=Iminor;
	}
      }
    }
    float W0;
    float W1;
    float W2;
    float sum=0;
    for(int i=0;i<pars->nInd;i++){
      W0=exp(pars->likes[s][i*10+angsd::majorminor[choiceMajor][choiceMajor]])*0.25;
      W1=exp(pars->likes[s][i*10+angsd::majorminor[choiceMajor][choiceMinor]])*0.5;
      W2=exp(pars->likes[s][i*10+angsd::majorminor[choiceMinor][choiceMinor]])*0.25;
      sum+=(W1+2*W2)/(2*(W0+W1+W2));
      //      fprintf(stderr,"W %f\t%f\t%f\n",W0,W1,W2);
    }
    if(sum/pars->nInd<0.5){
      pars->major[s]=choiceMajor;
      pars->minor[s]=choiceMinor;
    }
    else{
      pars->major[s]=choiceMinor;
      pars->minor[s]=choiceMajor;
    }
    //    fprintf(stderr,"%d %d\n",pars->major[s],pars->minor[s]);
  } 
}
