#include <vector>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include "parseArgs_bambi.h"
#include "shared.h"
#include "analysisFunction.h"

//daemon/dragon used for selecting only unique hits when doing soapsnp GL estimates. this should be modified.

// below is default samtools parameters
int uniqueOnly = 0;
int only_proper_pairs = 1;
int remove_bads = 1;

//read program parameters
args *getArgs(argStruct arguments){
  args *ret = new args;
  ret->callback= NULL;
  ret->show = 0;
  ret->uniqueOnly = 0;
  ret->nInd = 0;
  ret->type = 1;
  ret->nLines = 50;
  ret->inputfile=ret->inputfiles=ret->region=ret->regionfile=NULL;

  ret->jobtype = 2;
  ret->inputfile=angsd::getArg("-i",ret->inputfile,arguments);
  ret->inputfiles=angsd::getArg("-bam",ret->inputfiles,arguments);
  ret->region =angsd::getArg("-r",ret->region,arguments);
  only_proper_pairs =angsd::getArg("-only_proper_pairs",only_proper_pairs,arguments);
  ret->regionfile = angsd::getArg("-rf",ret->regionfile,arguments);
  remove_bads = angsd::getArg("-remove_bads",remove_bads,arguments);
  ret->nInd = angsd::getArg("-nInd",ret->nInd,arguments);
  ret->nLines = angsd::getArg("-nLines",ret->nLines,arguments);
  ret->type = angsd::getArg("-type",ret->type,arguments);
  ret->uniqueOnly = angsd::getArg("-uniqueOnly",ret->uniqueOnly,arguments);
  ret->show = angsd::getArg("-show",ret->show,arguments);
  



if(ret->inputfile && ret->inputfile[0]=='-'){
    fprintf(stderr,"[Error] Problem understanding inputfilename: %s\n",ret->inputfile);
    return NULL;
  }
  fprintf(stderr,"ret->inputfilesname=%s\n",ret->inputfile);
  uniqueOnly = ret->uniqueOnly;
  //  exit(0);
  return ret;
}

void print(args *a,FILE *fp){
  fprintf(fp,"\njobtype=%d, 1=view, 2=uppile\n",a->jobtype);
  fprintf(fp,"type=%d, 0=slow/secure 1=fast/insecure\n",a->type);
  fprintf(fp,"inputfile=%s (single sample)\n",a->inputfile);
  fprintf(fp,"inputfiles=%s (multisample)\n",a->inputfiles);
  fprintf(fp,"region=%s (single region)\n",a->region);
  fprintf(fp,"nInd=%d (single region)\n",a->nInd);
  fprintf(fp,"regionfile=%s (multiregion)\n\n",a->regionfile);
  //  fprintf(fp,"nLines=%d\tnThreads=%d\n",a->nLines,a->nThreads);
  fprintf(fp,"nLines=%d\n",a->nLines);
  fprintf(fp,"-GL INT: -1=mpileup 0=soap 1=samtools 2=gatk\n");
}
