#pragma once
#include <map>
#include <cstring>
#include <vector>
#include "shared.h"

#include "parseArgs.h"
#include "pileup.h"





class pileups{
private:
  binInput *bobj;
  txtInput *tobj;
  glfClass **obj;
  int *keepGoing;
  int filesLeft;

  lociPileup ultraStart;
  lociPileup ultraStop;

  char**chrnames;
  void print_lociPileup(const lociPileup &l);
  void parseLoci(lociPileup &l,const char *str,const cMap &cmap);
  cMap faiIndex;
  //used for killing the program and flushing the buffers. program will still segfault.
  //initialize signal handler
  cMap buildMap(const char * fname);
  //  funkyPars *collapse(pileworld::aMap &asso,size_t nInd,Matrix<double> ymat,Matrix<double> covmat,int getCovar,int minHigh,int sitePerm,int minCount,int adjust,int emIter,int doMaf,int doAsso,double assoCutoff,cMap &cmap,double **errors);
  funkyPars *collapse(pileworld::aMap &asso);
  int nFiles;
  int type;
public:
  //  pileups(progArgs *pg);
  pileups(char *faifile,char *lStart,char*lStop,std::vector<char *> &filenames,int type);
  ~pileups();
  //  funkyPars *fetch(int nFiles,int nLines,int chunkSize,progArgs *pg);
  funkyPars *fetch(int nLines,int chunkSize);
};
