#include "reader_sim.h"


void reader_sim::init(char *fname,int nInd_a){
  fprintf(stderr,"fname=%s\tnInd_a=%d\n",fname,nInd_a);
  nInd = nInd_a;
  gz = getGz(fname,"r");
}


funkyPars *reader_sim::fetch(int chunkSize){
  funkyPars *r = allocFunkyPars();  
  r->likes=new double*[chunkSize];
  r->sites=new loci[chunkSize];
  r->anc = new char[chunkSize];
  
  static int pos = 0;
  int i;
  for(i=0;i<chunkSize;i++){
    double *lk = new double [10*nInd];
    size_t bytesRead = gzread(gz,lk,sizeof(double)*10*nInd);
    if(bytesRead==0){
      delete [] lk;
      break;
    }else if(bytesRead!=sizeof(double)*10*nInd){
      fprintf(stderr,"\t-> Error reading full chunk\n");
      exit(0);
    }else{ 
      r->likes[i] = lk;
      r->sites[i].chromo = strdup("dummy1");
      r->sites[i].position = i+pos;
      r->anc[i] = 0;
    }
  }
  if(i==0){
    //the code below is
   


    delete r->covStruct;
    delete r->results->asso;
    delete r->results->freq;
    delete r->results; 
    delete [] r->likes;
    delete [] r->sites;
    delete [] r->anc;
    delete r;
    return NULL;
  }
  r->numSites=i;
  pos += i;
  
  return r;
}

