#include <vector>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <sys/stat.h>

#include "utility.h"
/*
// Checking for file existence, using stat.h.
int fexists(const char* str){///@param str Filename given as a string.
  struct stat buffer ;
  return (stat(str, &buffer )==0 ); /// @return Function returns 1 if file exists.
}
*/
extern int fexists(const char* str);

extern size_t fsize(const char* fname);


FILE *getFILE(const char*fname,const char* mode);

std::vector<char*> getFilenames(const char * name,int nItems){
  if(!fexists(name)){
    fprintf(stderr,"\t-> Problems opening file: %s\n",name);
    exit(0);
  }
  const char* delims = " \t\n\r";
  std::vector<char*> ret;
  FILE *fp =getFILE(name,"r");
  char buffer[fsize(name)+1];
  if(fsize(name)!=fread(buffer,1,fsize(name),fp))
    fprintf(stderr,"[%s] Problems reading %lu from: %s\n",__FUNCTION__,fsize(name),name);
  buffer[fsize(name)] = '\0';
  char *tok = strtok(buffer,delims);
  while(tok!=NULL){
    if(tok[0]!='#'){
      ret.push_back(strdup(tok));
      nItems--;
      if(nItems==0)
	break;
    }
    tok = strtok(NULL,delims);
  }
  fprintf(stderr,"\t-> From file: %s we read %lu\n",name,ret.size());
  fclose(fp);
  return ret;
}

void print(const std::vector<char *>& vect,FILE *fp){
  for(size_t i=0;i<vect.size();i++)
        fprintf(fp,"vect[%lu] = %s\n",i,vect[i]);
  
}


std::vector<char*> getRegions(const char * name){
  if(!fexists(name)){
    fprintf(stderr,"\t-> Problems opening file: %s\n",name);
    exit(0);
  }
  const char* delims = " \t\n\r";
  std::vector<char*> ret;
  FILE *fp =getFILE(name,"r");
  char buffer[fsize(name)+1];
  if(fsize(name)!=fread(buffer,1,fsize(name),fp))
    fprintf(stderr,"[%s] Problems reading %lu from: %s\n",__FUNCTION__,fsize(name),name);
  buffer[fsize(name)]='\0';
  
  char *tok = strtok(buffer,delims);

  while(tok!=NULL){
    if(tok[0]!='#'){
      ret.push_back(strdup(tok));
    }
    tok = strtok(NULL,delims);
  }

  fprintf(stderr,"\t-> From regionsfile: %s we read %lu\n",name,ret.size());
  fclose(fp);
  return ret;
}

