
#include <stdlib.h>
#include <stdio.h>
#include <cstring>
#include <map>
#include <zlib.h>
#include "bambi_interface.h"
#ifndef _types_t
#define _types_t
typedef short unsigned int suint;
//typedef int suint;
//typedef float double;

#define LENS 10000


// struct for covar class - classy
typedef struct{
  double *res; 
}funkyCovar;


typedef struct{
  int nInd;//number of inds inferred from filelists, and set accordingly in hidden places incode
  int argc;
  char **argv;
  int inputtype;
  char *inputFilename;
  int *usedArgs; //array of ints telling if args been used
}argStruct;



extern int refToInt[256];
extern char intToRef[5];

struct ltstr
{
  bool operator()(const char* s1, const char* s2) const
  {
    return strcmp(s1, s2) < 0;
  }
};


typedef std::map<int,int> iMap;// inner map (witin IN chromosome map)
typedef std::map<char *,iMap*,ltstr> oMap; // map from chromo -> correct INNER map






template<typename T>
struct Matrix {
  int x;
  int y;
  T **matrix;
};

extern int verbose;

typedef struct {
  char * chromo;
  int position;
}loci;

/*
typedef struct {
  // one dimensional options

  int doGeno;
  int doMaf;
  int doPost;
  int doGlf;//this should be an argument . 1=glf out format, 2= beagle 
  int doAsso; //1: su yeon
  int getCovar;
  int adjust;
  int sitePerm;
  int minHigh;
  int minCount;
  int emIter;
  int estError;
  double assoCutoff;
//int printLike; // now being used by doGlf

  float minMaf;
  int minInd;



  int emIter;


}funkyOpt;
*/


typedef struct{
  double *pml; 
  double *pmlun;
  double *pEM; 
  double *pEMun; 
  double *pmlSNP; 
  double *pmlunSNP;
  double *pEMSNP; 
  double *pEMunSNP;
  int *keepInd; 
}funkyPrintFreq;

typedef struct{

  double **stat;
  int **keepInd;
  double *freq;
  double *lrt_snp;
  int *highHe;
  int *highHo;
}funkyPrintAsso;


typedef struct {
  funkyPrintFreq *freq;
  funkyPrintAsso *asso;
  
}funkyPrint;


typedef struct {
  FILE *oFileCovar;
  double **covRes;
}funkyFiles;

typedef struct {
  double *freq;
  double *F;
}funkyHWE;

typedef struct {
  //dynamic
  loci *sites;
  suint **counts;//[nsites][5xiNind] !!!! nope! only 4
  double **likes;
  double **post;
  double *phat;
  double **errors;
  int *major;
  int *minor;
  char *ref;
  char *anc;

  //primitives
  int numSites;
  int nInd;
  int **depth;
  int inputtype;

  //for print
  funkyPrint *results;

  //sites removed in analysis and print
  int *keepSites;
  int chunkNumber;
  
 
  ////// add structs from analysis classes - classy -
  funkyCovar *covStruct;
  funkyHWE *hweStruct;
  //  double *sfsEst;
  
  fcb *for_callback;
  chunkyT *chk;
  int killSig;
}funkyPars;


size_t fsize(const char* fname);
int fexists(const char* str);//{///@param str Filename given as a string.
FILE *openFile(const char* a,const char* b);
gzFile openFileGz(const char* a,const char* b,const char *mode);
void init(const char *outfiles,int maximalThread,int inputtype,argStruct arguments);
//void init(const char *condition,Matrix<double> matY,Matrix<double> matCov,int doMaf, int doGlf, int doAsso,int doError,int FROMSOAP,int maximalThread,char *ref,char *anc,int doSNP,int doSFS,int flag,int doGeno,argStruct arguments);
void destroy();
 int main_analysis(funkyPars *p);

//a simple function just to release the mutex whenever therets a nasty bug
//This function should be name mangled to c style
#ifdef __cplusplus
extern "C" void release();
#endif

double* allocDoubleArray(int len);
int* allocIntArray(int len);

//void interface(funkyPars *p);
void selector(funkyPars *p);
//Matrix<double> getMatrix(const char *name,int doBinary);



struct cmp_loci {
  bool operator()(const loci& first,const  loci& second) {
    int tmp = std::strcmp(first.chromo, second.chromo);
    if(tmp!=0)
      return tmp<0;
    else
      return first.position<second.position;
  }
};


funkyPars *allocFunkyPars();
FILE *getFILE(const char*fname,const char* mode);

void print_array(FILE *fp,double *ary,int len);

void print_array(FILE *fp,int *ary,int len);


gzFile getGz(const char*fname,const char* mode);
FILE *getFile(const char*fname,const char *mode);
void deallocFunkyPars(funkyPars *p);
#define LOGMAX 20000   // pre-computed logfactorial 
#endif
